com.r3corda.protocols / RatesFixProtocol

# RatesFixProtocol

`open class RatesFixProtocol : ProtocolLogic<Unit>`

This protocol queries the given oracle for an interest rate fix, and if it is within the given tolerance embeds the fix in the transaction and then proceeds to get the oracle to sign it. Although the call method combines the query and signing step, you can run the steps individually by constructing this object and then using the public methods for each step.

### Exceptions

`FixOutOfRange` - if the returned fix was further away from the expected rate by the given amount.

### Types

QUERYING | `class QUERYING : Step`
QueryRequest | `class QueryRequest : AbstractRequestMessage`
SIGNING | `object SIGNING : Step`
SignRequest | `class SignRequest : AbstractRequestMessage`
WORKING | `object WORKING : Step`

### Exceptions

FixOutOfRange | `class FixOutOfRange : Exception`

### Constructors

<init> | `RatesFixProtocol(tx: TransactionBuilder, oracle: NodeInfo, fixOf: FixOf, expectedRate: BigDecimal, rateTolerance: BigDecimal, progressTracker: ProgressTracker = RatesFixProtocol.tracker(fixOf.name))` This protocol queries the given oracle for an interest rate fix, and if it is within the given tolerance embeds the fix in the transaction and then proceeds to get the oracle to sign it. Although the call method combines the query and signing step, you can run the steps individually by constructing this object and then using the public methods for each step.

### Properties

progressTracker | `open val progressTracker: ProgressTracker` Override this to provide a ProgressTracker. If one is provided and stepped, the framework will do something helpful with the progress reports. If this protocol is invoked as a sub-protocol of another, then the tracker will be made a child of the current step in the parent. If its null, this protocol doesnt track progress.
tx | `val tx: TransactionBuilder`

### Inherited Properties

logger | `val logger: <ERROR CLASS>` This is where you should log things to.
psm | `lateinit var psm: ProtocolStateMachine<*>` Reference to the Fiber instance that is the top level controller for the entire flow.
serviceHub | `val serviceHub: ServiceHub` Provides access to big, heavy classes that may be reconstructed from time to time, e.g. across restarts

### Functions

beforeSigning | `open fun beforeSigning(fix: Fix): Unit` You can override this to perform any additional work needed after the fix is added to the transaction but before its sent back to the oracle for signing (for example, adding output states that depend on the fix).
call | `open fun call(): Unit` This is where you fill out your business logic.
query | `fun query(): Fix`
sign | `fun sign(): LegallyIdentifiable`

### Inherited Functions

receive | `fun <T : Any> receive(topic: String, sessionIDForReceive: Long): UntrustworthyData<T>` `fun <T : Any> receive(topic: String, sessionIDForReceive: Long, clazz: Class<T>): UntrustworthyData<T>`
send | `fun send(topic: String, destination: MessageRecipients, sessionID: Long, obj: Any): Unit`
sendAndReceive | `fun <T : Any> sendAndReceive(topic: String, destination: MessageRecipients, sessionIDForSend: Long, sessionIDForReceive: Long, obj: Any): UntrustworthyData<T>`
subProtocol | `fun <R> subProtocol(subLogic: ProtocolLogic<R>): R` Invokes the given subprotocol by simply passing through this ProtocolLogics reference to the ProtocolStateMachine and then calling the call method.

### Companion Object Properties

TOPIC | `val TOPIC: String`
TOPIC_QUERY | `val TOPIC_QUERY: String`
TOPIC_SIGN | `val TOPIC_SIGN: String`

### Companion Object Functions

tracker | `fun tracker(fixName: String): ProgressTracker`